/*******************************************************************************
 *	@file			DLSound.cpp
 *	@brief			DirectX Library
 *
 *	@date			20-Jun-2010(Sun)
 ******************************************************************************/

// vvZbT---------------------------------------------------------------
#include "DLSound.h"

/*******************************************************************************
 *	@namespace	DL
 ******************************************************************************/
namespace	DL
{

// O[oϐ---------------------------------------------------------

// ֐vg^Cv錾---------------------------------------------------

// -----------------------------------------------------------------------------
/*******************************************************************************
 *	@fn				BOOL CALLBACK CDLSound::DSEnumCallback( LPGUID lpGuid,
 *															LPCSTR lpcstrDescription,
 *															LPCSTR lpcstrModule,
 *															LPVOID lpContext )
 *	@param[in]		lpGuid						foCXGUID
 *	@param[in]		lpcstrDescription			foCX
 *	@param[in]		lpcstrModule				W[
 *	@param[in]		lpContext					nh
 *	@retval			int							TRUE=p/FALSE=~
 *	@brief			foCX̗񋓁Ao^
 ******************************************************************************/
BOOL CALLBACK CDLSound::DSEnumCallback( LPGUID lpGuid,
										LPCSTR lpcstrDescription,
										LPCSTR lpcstrModule,
										LPVOID lpContext )
{
	CDLSound* pSnd = static_cast<CDLSound*>( lpContext );

	// foCXo^
	const DSDEVICE& v = DSDEVICE( lpGuid, lpcstrDescription, lpcstrModule );
	pSnd->m_vDevice.push_back( v );

	return TRUE;
}

/*******************************************************************************
 *	@fn				CDLSound::CDLSound( void )
 *	@retval			none						Ȃ
 *	@brief			RXgN^
 ******************************************************************************/
CDLSound::CDLSound( void )
	: m_lpSound( NULL )

	, m_hWnd()

	, m_vDevice()
	, m_DSCaps()
	, m_dwSpeaker( 0 )
{
}

/*******************************************************************************
 *	@fn				CDLSound::~CDLSound( void )
 *	@retval			none						Ȃ
 *	@brief			fXgN^
 ******************************************************************************/
CDLSound::~CDLSound( void )
{
}

/*******************************************************************************
 *	@fn				int CDLSound::Init( const SDLParam& SDL )
 *	@param[in]		SDL							DL\
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			
 ******************************************************************************/
int CDLSound::Init( const SDLParam& SDL )
{
	m_hWnd = SDL.m_hWnd;
	HRESULT hr = DS_OK;

	// TEhEfoCX̗
	hr = ::DirectSoundEnumerate( static_cast<LPDSENUMCALLBACK>( DSEnumCallback ),
								 static_cast<VOID*>( this ) );

	// IDirectSound8 C^[tFCX̎擾
	hr = ::DirectSoundCreate8( NULL, &m_lpSound, NULL );
	if( FAILED( hr ) )
	{
		DXTRACE_ERR( "DirectSoundCreate8()", hr );
		return FALSE;
	}

	// x̐ݒ
	hr = m_lpSound->SetCooperativeLevel( m_hWnd, DSSCL_PRIORITY );
	if( FAILED( hr ) )
	{
		DXTRACE_ERR( "SetCooperativeLevel()", hr );
		return FALSE;
	}

	// foCX̐\
	m_DSCaps.dwSize = sizeof( DSCAPS );
	hr = m_lpSound->GetCaps( &m_DSCaps );
	if( FAILED( hr ) )
	{
		DXTRACE_MSG( "GetCaps()" );
		return FALSE;
	}

	// Xs[J[̒
	hr = m_lpSound->GetSpeakerConfig( &m_dwSpeaker );
	if( FAILED( hr ) )
	{
		DXTRACE_MSG( "GetSpeakerConfig()" );
		return FALSE;
	}
	DSSPEAKER_CONFIG( m_dwSpeaker );
	DSSPEAKER_GEOMETRY( m_dwSpeaker );


	return TRUE;
}

/*******************************************************************************
 *	@fn				int CDLSound::End( void )
 *	@retval			int							TRUE=OK/FALSE=NG
 *	@brief			I
 ******************************************************************************/
int CDLSound::End( void )
{
	// IDirectSound8 C^[tFCX̉
	_RELEASE( m_lpSound );
	// TEhEfoCX̃NA
	m_vDevice.clear();

	return TRUE;
}


}	// namespace	DL
